// VideoSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VideoSample.h"
#include "VideoSampleDlg.h"

#include <vfw.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVideoSampleDlg dialog

CVideoSampleDlg::CVideoSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVideoSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVideoSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVideoSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVideoSampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVideoSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CVideoSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BeginCap, OnBeginCap)
	ON_BN_CLICKED(IDC_GrabFrame, OnGrabFrame)
	ON_BN_CLICKED(IDC_SaveFrame, OnSaveFrame)
	ON_BN_CLICKED(IDC_SaveCapFile, OnSaveCapFile)
	ON_BN_CLICKED(IDC_SetupVideoFormat, OnSetupVideoFormat)
	ON_BN_CLICKED(IDC_CapSetup, OnCapSetup)
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVideoSampleDlg message handlers

BOOL CVideoSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVideoSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVideoSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CVideoSampleDlg::OnCancel() 
{
	capDriverDisconnect(m_hCapture);
	CDialog::OnCancel();
}

void CVideoSampleDlg::OnBeginCap() 
{
	if(GetDlgItem(IDC_GrabFrame)->IsWindowEnabled()){
		//ʹõǰΪOverlayڡ  
		capOverlay (m_hCapture, TRUE);
		GetDlgItem(IDC_SaveCapFile)->EnableWindow(true);
	}
	else{
		GetDlgItem(IDC_GrabFrame)->EnableWindow(true);
		GetDlgItem(IDC_SaveFrame)->EnableWindow(true);
		GetDlgItem(IDC_SaveCapFile)->EnableWindow(true);
		CAPTUREPARMS m_CaptureParms;
		m_hCapture = capCreateCaptureWindow ("Cap",WS_EX_CONTROLPARENT
			| WS_CHILD | WS_VISIBLE, 4, 4, 320, 240, m_hWnd, 0);
		
		// Make sure you are connecting to the right driver index!
		capDriverConnect (m_hCapture, 0); 
		//ǰʹm_hCaptureӲл֡
		capCaptureGetSetup (m_hCapture, &m_CaptureParms, sizeof (m_CaptureParms));
		//ʹõǰΪOverlayڡ  
		capOverlay (m_hCapture, TRUE);
	}
}

void CVideoSampleDlg::OnGrabFrame() 
{
	capGrabFrame(m_hCapture);	
	GetDlgItem(IDC_SaveCapFile)->EnableWindow(false);
}

void CVideoSampleDlg::OnSaveFrame() 
{
	capFileSaveDIB(m_hCapture,"e:\\user\\test.bmp"); 
}

void CVideoSampleDlg::OnSaveCapFile() 
{
	//capFileSaveAs( m_hCapture,"e:\\user\\test.avi"); 
}

void CVideoSampleDlg::OnSetupVideoFormat() 
{
	capDlgVideoCompression(m_hCapture);
}

void CVideoSampleDlg::OnCapSetup() 
{
	capDlgVideoSource(m_hCapture);
}

void CVideoSampleDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	::MoveWindow(m_hCapture,4, 4, 220, 240,TRUE);	
	::MoveWindow(m_hCapture,4, 4, 320, 240,FALSE);	
}
